	SUBROUTINE BZINT
****************************************************
*  Calculate BZ integrals and find Fermi energy    *
****************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),NBNDF(NPANMAX),NBNDE(NPANMAX)
     &   ,NBNDT(NPANMAX)
	DIMENSION  Z(NSORTMAX),ZCOR(NSORTMAX),VEL(3)
     &   ,SPDOS(NSPINMAX),SPVEL(3,NSPINMAX)
	CHARACTER*10 TXTEL(NSORTMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from init
	COMMON /MULTRO/ Z,ZCOR                               !!! from init
	COMMON /EFERMI/ EF,DOS,VEL,SPDOS,SPVEL               !!! Fermi energy
	COMMON /KAPPAR/ NPAN                                 !!! frin init
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! from init
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /TXTEL/  TXTEL                                !!! from init
	DATA PI/3.141592653589793D0/
	ZVAL=0.0
	DO 10 ISORT=1,NSORT                       !!! define total valence charge
	ZVAL=ZVAL+(Z(ISORT)-ZCOR(ISORT))*NHSORT(ISORT)
  10    CONTINUE
	ZSEM=0.D0
	DO 20 IPAN=2,NPAN                         !!! define semicore charge
	ZSEM=ZSEM+2.D0*NBNDT(IPAN)
  20    CONTINUE
	CALL SRBANDS(EF)                          !!! read energy bands
	CALL EFINS(EF,ZVAL-ZSEM)                  !!! recognize insulating case
	CALL EFSEARCH(EF,ZVAL-ZSEM,EF)            !!! search for Fermi energy
	CALL TTRVEL(EF,DOS,VEL,SPDOS,SPVEL)       !!! get velocities
        CALL TTRINT2(EF)                          !!! get partial numbers states
	CALL SNBANDS(EF)                          !!! define # of filled bands
	CALL LRBANDS(EF)                          !!! define # of bands for LR
	END



	SUBROUTINE SRBANDS(EF)
***********************************************************
*  Reads/writes energy bands to the file.                 *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &    ,NDIV(3),NDIW(3),NDIW0(3),NBNDT0(NPANMAX)
	DIMENSION EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX),PNT(3,KMAX)
     &     ,EARW(NDIMMAX*NSPINMAX,KMAX,NPANMAX),PNW(3,KMAX)
	CHARACTER*60 SCRFILE(100),HUBFILE,HOPFILE,OPTFILE,ENRFILE
     &	   ,CONFILE,FTRFILE,KOVFILE,PSIFILE,TMPFILE,BNDFILE,DFILE
	LOGICAL EXIST
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM
	COMMON /MESH/   NPNT,PNT                             !!! from ttrmsh
	COMMON /MESW/   NPNW,PNW                             !!! from ttrmsh
	COMMON /INTTR/  NDIV,NDIW                            !!! from init
	COMMON /ENERGY/ EARR                                 !!! from lmtbnd
	COMMON /ENRWGT/ EARW                                 !!! from lmtbnd
	COMMON /KAPPAR/ NPAN                                 !!! frin init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! # of bands
        COMMON /INP1/   ICHUB,ICHOP,ICOPT,ICENR              !!! from readini
        COMMON /INP2/   HUBFILE,HOPFILE,OPTFILE,ENRFILE         
        COMMON /OUT0/   SCRFILE                              !!! from init
        COMMON /OUT1/   ICCON,ICFTR,ICKOV,ICPSI,ICTMP,ICBND  !!! from readini
        COMMON /OUT2/   CONFILE,FTRFILE,KOVFILE,PSIFILE,TMPFILE
     &                 ,BNDFILE
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /WORD/   NVAL                                 !!! from nmtdata
	COMMON /UNIT/   IUN                                  !!! output unit
	DATA PI/3.141592653589793D0/
C   OPEN FILE FOR ENERGY BAND STRUCTURE
	NRECL=0
	DO JPAN=1,NPAN
	NRECL=MAX(NRECL,NVAL/2*NBNDT(JPAN)*NSPIN)
	ENDDO
	IF(ICBND.EQ.0)DFILE=SCRFILE(10)
	IF(ICBND.EQ.1)DFILE=BNDFILE
	IF(ICBND.EQ.2)DFILE=BNDFILE
	OPEN(UNIT=10,FILE=DFILE,STATUS='OLD',ACCESS='DIRECT',
     &  FORM='UNFORMATTED',RECL=NVAL)
	READ(10,REC=1)NRECL0
	CLOSE(10)
	IF(NRECL0.NE.NRECL)STOP'<BZINT> NRECL.NE.NRECL0 IN BNDFILE'
	OPEN(UNIT=10,FILE=DFILE,STATUS='OLD',ACCESS='DIRECT',
     &  FORM='UNFORMATTED',RECL=NRECL)
C   OPEN FILE FOR WAVE COEFFICIENTS
	NRECL=0
	DO ISORT=1,NSORT  !!! estimate record lenght
	MAXLM=(ILST(ISORT)+1+1)**2+(ILSB(ISORT)+1)**2
	NRECL=MAX(NRECL,NVAL*MAXLM*NATOM)
	ENDDO
	IF(ICPSI.EQ.0)DFILE=SCRFILE(15)
	IF(ICPSI.EQ.1)DFILE=PSIFILE
	IF(ICPSI.EQ.2)DFILE=PSIFILE
	OPEN(UNIT=15,FILE=DFILE,STATUS='OLD',ACCESS='DIRECT',
     &  FORM='UNFORMATTED',RECL=NVAL)
	READ(15,REC=1)NRECL0
	CLOSE(15)
	IF(NRECL0.NE.NRECL)STOP'<BZINT> NRECL.NE.NRECL0 IN PSIFILE'
	OPEN(UNIT=15,FILE=DFILE,STATUS='OLD',ACCESS='DIRECT',
     &  FORM='UNFORMATTED',RECL=NRECL)
C  READ BAND STRUCTURE
	DO IPAN=1,NPAN
	DO IPNT=1,NPNT
	IREC=1+IPNT+NPNT*(IPAN-1)
	READ(10,REC=IREC)((EARR(IBNDS+NSPIN*(IBNDT-1),IPNT,IPAN),
     &  IBNDS=1,NSPIN),IBNDT=1,NBNDT(IPAN))
	ENDDO
	ENDDO
C   OPEN FILE FOR ENERGY BAND STRUCTURE USED FOR WEIGHTS
	INQUIRE(FILE=ENRFILE,EXIST=EXIST)
	IF(EXIST)THEN
	INQUIRE(FILE=ENRFILE,RECL=NRECL)
CWRONG  IF(WRONG)THEN           !!! wrong compiler statement
	NRECL=NVAL
	OPEN(20,FILE=ENRFILE,STATUS='OLD',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL)
	READ(20,REC=1)NRECL
	CLOSE(20)
CWRONG  ENDIF
	OPEN(20,FILE=ENRFILE,STATUS='OLD',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL)
	READ(20,REC=1)NRECL,NDIW0(1),NDIW0(2),NDIW0(3),NPNW0,
     &  NPAN0,(NBNDT0(IPAN),IPAN=1,NPAN0),NSPIN0
	IF(NSPIN0.NE.NSPIN)
     &  STOP'<SRBANDS>: NSPIN MISMATCHES IN ENRFILE'
	DO I=1,3
	IF(NDIW0(I).NE.NDIW(I))
     &  STOP'<SRBANDS>: NDIW MISMATCHES IN ENRFILE'
	ENDDO
	IF(NPNW0.NE.NPNW)
     &  STOP'<SRBANDS>: # OF POINTS MISMATCHES IN ENRFILE'
	IF(NPAN0.NE.NPAN)
     &  STOP'<SRBANDS>: # OF PANELS MISMATCHES IN ENRFILE'
	DO IPAN=1,NPAN
	IF(NBNDT(IPAN).NE.NBNDT0(IPAN))
     &  STOP'<SRBANDS>: # OF BANDS MISMATCHES IN ENRFILE'
	ENDDO
	DO IPAN=1,NPAN
	DO IPNW=1,NPNW
	IREC=IPNW+NPNW*(IPAN-1)+1
	READ(20,REC=IREC)((EARW(IBNDS+NSPIN*(IBNDT-1),IPNW,IPAN),
     &  IBNDS=1,NSPIN),IBNDT=1,NBNDT(IPAN))
	DO IPNT=1,NPNT
	IF(ABS(PNT(1,IPNT)-PNW(1,IPNW)).LE.1.D-10.AND.
     &     ABS(PNT(2,IPNT)-PNW(2,IPNW)).LE.1.D-10.AND.
     &     ABS(PNT(3,IPNT)-PNW(3,IPNW)).LE.1.D-10)THEN
	DO IBNDS=1,NSPIN
	DO IBNDT=1,NBNDT(IPAN)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DIFF=ABS(EARW(IBAND,IPNW,IPAN)-EARR(IBAND,IPNT,IPAN))
	IF(DIFF.GE.1.D-10)
     &  PRINT*,'ENERGY BANDS MISMATCH FOR GRIDS NDIW AND NDIV',
     &  DIFF,IBNDS,IBNDT,IPNT,IPAN
	ENDDO
	ENDDO
	ENDIF
	ENDDO
	ENDDO
	ENDDO
	CLOSE(20)
	ELSEIF(.NOT.EXIST)THEN
	NRECL=0
	DO JPAN=1,NPAN
	NRECL=MAX(NRECL,NVAL/2*NBNDT(JPAN)*NSPIN)
	ENDDO
	NRECL=MAX(NRECL,NVAL/2*(7+NPAN))
	OPEN(UNIT=20,FILE=ENRFILE,STATUS='NEW',ACCESS='DIRECT',
     &  FORM='UNFORMATTED',RECL=NRECL)
	WRITE(20,REC=1)NRECL,NDIW(1),NDIW(2),NDIW(3),NPNW,
     &  NPAN,(NBNDT(IPAN),IPAN=1,NPAN),NSPIN
	DO IPAN=1,NPAN
	DO IPNT=1,NPNT
	DO IBNDS=1,NSPIN
	DO IBNDT=1,NBNDT(IPAN)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	EARW(IBAND,IPNT,IPAN)=EARR(IBAND,IPNT,IPAN)
	ENDDO
	ENDDO
	IREC=IPNT+NPNT*(IPAN-1)+1
	WRITE(20,REC=IREC)((EARW(IBNDS+NSPIN*(IBNDT-1),IPNT,IPAN),
     &  IBNDS=1,NSPIN),IBNDT=1,NBNDT(IPAN))
	ENDDO
	ENDDO
	CLOSE(20)
	ENDIF
	END


	SUBROUTINE EFINS(EF,ZVAL)
***********************************************************
*  Recognizes insulating case.                            *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
	DIMENSION EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM
	COMMON /ENERGY/ EARR                                 !!! from lmtbnd
	COMMON /MESH/   NPNT                                 !!! from ttrmsh
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! # of bands
	COMMON /ORBS/   NORBS                                !!! from init
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /UNIT/   IUN                                  !!! output unit
	DATA PI/3.141592653589793D0/
	IF(ABS(MOD(ZVAL,2.D0)).GE.1.D-10)RETURN
	NB=ZVAL/2.D0
	EVMAX=EARR(1,1,1)
	EEMIN=EARR(NBNDT(1)*NSPIN,1,1)
	DO IPNT=1,NPNT
	DO IV=1,NB
	DO IBNDS=1,NSPIN
	IBAND=IBNDS+NSPIN*(IV-1)
	EVMAX=MAX(EVMAX,EARR(IBAND,IPNT,1))
	ENDDO
	ENDDO
	DO IE=NB+1,NBNDT(1)
	DO IBNDS=1,NSPIN
	IBAND=IBNDS+NSPIN*(IE-1)
	EEMIN=MIN(EEMIN,EARR(IBAND,IPNT,1))
	ENDDO
	ENDDO
	ENDDO
	GAP=EEMIN-EVMAX
	IF(GAP.LE.0.D0)RETURN
	EF=EVMAX+1.D-06
	WRITE(IUN,1010)
	WRITE(IUN,1020)GAP,GAP*13.6058D0
1010    FORMAT(1X,'Semiconducting band structure discovered --------->')
1020    FORMAT(1X,'dielectric gap value is ',G14.7,' Ry ; ',G14.7,' eV')
	END






	SUBROUTINE SNBANDS(EF)
*************************************************
*   Define a number of filled and empty bands   *
*************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &    ,NBNDEMP(2),NBNDFIL(2)
	DIMENSION EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
     &    ,PNT(3,KMAX)
	CHARACTER TXTEL(NSORTMAX)*10,TXTSP(2)*2
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT
	COMMON /KAPPAR/ NPAN
	COMMON /ENERGY/ EARR
	COMMON /ORBS/   NORBS
	COMMON /SPIN/   NSPIN
	COMMON /MESH/   NPNT,PNT
	COMMON /UNIT/   IUN
	COMMON /TXTEL/  TXTEL,TXTSP
C DEFINE # OF FILLED BANDS IF THERE IS NO SPIN-ORBIT COUPLING
	IF(NORBS.EQ.1)THEN
	DO IBNDS=1,NSPIN
	NBNDEMP(IBNDS)=0
	NBNDFIL(IBNDS)=0
	DO IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	N1=0
	N2=0
	DO IPNT=1,NPNT
	IF(EARR(IBAND,IPNT,1).LT.EF)THEN
	N1=IBNDT
	ELSEIF(EARR(IBAND,IPNT,1).GE.EF)THEN
	N2=IBNDT
	ENDIF
	ENDDO
	IF(N1.NE.0.AND.N2.EQ.0)THEN
	NBNDEMP(IBNDS)=N1+1
	ELSEIF(N1.EQ.0.AND.N2.NE.0)THEN
	NBNDFIL(IBNDS)=N2-1
	EXIT
	ENDIF
	ENDDO
	ENDDO
	MBNDFIL=MAX(NBNDFIL(1),NBNDFIL(NSPIN))
	MBNDEMP=MIN(NBNDEMP(1),NBNDEMP(NSPIN))
C DEFINE # OF FILLED BANDS IF THERE IS SPIN-ORBIT COUPLING
	ELSEIF(NORBS.EQ.2)THEN
	MBNDEMP=0
	MBNDFIL=0
	DO IBAND=1,NBNDT(1)*NSPIN
	N1=0
	N2=0
	DO IPNT=1,NPNT
	IF(EARR(IBAND,IPNT,1).LT.EF)THEN
	N1=IBAND
	ELSEIF(EARR(IBAND,IPNT,1).GT.EF)THEN
	N2=IBAND
	ENDIF
	ENDDO
	IF(N1.NE.0.AND.N2.EQ.0)THEN
	MBNDEMP=N1+1
	ELSEIF(N1.EQ.0.AND.N2.NE.0)THEN
	MBNDFIL=N2-1
	EXIT
	ENDIF
	ENDDO
	IF(MOD(MBNDFIL,2).NE.0)MBNDFIL=MBNDFIL-1
	IF(MOD(MBNDEMP,2).NE.0)MBNDEMP=MBNDEMP+1
	IF(MBNDFIL.LT.0)MBNDFIL=0
	MBNDFIL=MBNDFIL/2
	MBNDEMP=MBNDEMP/2
	ENDIF
	IF(NBNDF(1).LT.MBNDFIL)PRINT*,'# of filled bands mismatches'
	IF(NBNDE(1).GT.MBNDEMP)PRINT*,'# of empty  bands mismatches'
	WRITE(IUN,1010)MBNDEMP-1,NBNDE(1)-1
	WRITE(IUN,1020)MBNDFIL-MBNDEMP+1,NBNDF(1)-NBNDE(1)+1
C       IF(NBNDF(1).LT.MBNDFIL.OR.NBNDE(1).GT.MBNDEMP)STOP
C    &  'Correct NFF and/or NEF in INIFILE and run the task again'
C  PRINT BANDS AT THE G-POINT
	IPNTG=0
	DO IPNT=1,NPNT
	ABSPNT=SQRT(PNT(1,IPNT)**2+PNT(2,IPNT)**2+PNT(3,IPNT)**2)
	IF(ABSPNT.LE.1.D-04)IPNTG=IPNT
	ENDDO
	IF(IPNTG.NE.0.AND.NORBS.EQ.1)THEN
	DO IBNDS=1,NSPIN
	IF(NSPIN.EQ.1)WRITE(IUN,1030)
	IF(NSPIN.EQ.2)WRITE(IUN,1040)TXTSP(IBNDS)
	WRITE(IUN,1050)(EARR(IBNDS+NSPIN*(IBNDT-1),IPNTG,1),
     &  IBNDT=1,NBNDT(1))
	ENDDO
	ELSEIF(IPNTG.NE.0.AND.NORBS.EQ.2)THEN
	WRITE(IUN,1030)
	WRITE(IUN,1050)((EARR(IBNDS+NSPIN*(IBNDT-1),IPNTG,1),
     &  IBNDS=1,NSPIN),IBNDT=1,NBNDT(1))
	ENDIF
1010    FORMAT(1X,'# of fully filled bands =',I4,'; input # =',I4)
1020    FORMAT(1X,'# of bands crossing Ef  =',I4,'; input # =',I4)
1030    FORMAT(1X,'Energy bands at the Gamma-point are')
1040    FORMAT(1X,'Energy bands at the Gamma-point for spin-',
     &  A2,' states are')
1050    FORMAT(1X,5(G12.5,1X))
	END



	SUBROUTINE LRBANDS(EF)
***********************************************************
*  Prints the bands within +/- 0.5 Ry window from Ef.     *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &    ,NBNDFIL(2),NBNDEMP(2)
	DIMENSION EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM
	COMMON /ENERGY/ EARR                                 !!! from lmtbnd
	COMMON /MESH/   NPNT                                 !!! from ttrmsh
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! # of bands
	COMMON /ORBS/   NORBS                                !!! from init
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /UNIT/   IUN                                  !!! output unit
	DATA PI/3.141592653589793D0/
	WINDOW=0.5 ! Ry
C DEFINE # OF FILLED BANDS IF THERE IS NO SPIN-ORBIT COUPLING
	IF(NORBS.EQ.1)THEN
	DO IBNDS=1,NSPIN
	NBNDFIL(IBNDS)=0
	DO IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IWINF=0
	DO IPNT=1,NPNT
	IF(EARR(IBAND,IPNT,1).LT.EF-WINDOW)IWINF=IWINF+1
	ENDDO
	IF(IWINF.EQ.NPNT)NBNDFIL(IBNDS)=IBNDT
	ENDDO
	NBNDEMP(IBNDS)=NBNDT(1)+1
	DO IBNDT=NBNDT(1),1,-1
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IWINE=0
	DO IPNT=1,NPNT
	IF(EARR(IBAND,IPNT,1).GT.EF+WINDOW)IWINE=IWINE+1
	ENDDO
	IF(IWINE.EQ.NPNT)NBNDEMP(IBNDS)=IBNDT
	ENDDO
	ENDDO
	MBNDFIL=MAX(NBNDFIL(1),NBNDFIL(NSPIN))
	MBNDEMP=MIN(NBNDEMP(1),NBNDEMP(NSPIN))
C DEFINE # OF FILLED BANDS IF THERE IS SPIN-ORBIT COUPLING
	ELSEIF(NORBS.EQ.2)THEN
	MBNDFIL=0
	DO IBAND=1,NBNDT(1)*NSPIN
	IWINF=0
	DO IPNT=1,NPNT
	IF(EARR(IBAND,IPNT,1).LT.EF-WINDOW)IWINF=IWINF+1
	ENDDO
	IF(IWINF.EQ.NPNT)MBNDFIL=IBAND
	ENDDO
	MBNDEMP=NBNDT(1)*NSPIN+1
	DO IBAND=1,NBNDT(1)*NSPIN
	IWINE=0
	DO IPNT=1,NPNT
	IF(EARR(IBAND,IPNT,1).GT.EF+WINDOW)IWINE=IWINE+1
	ENDDO
	IF(IWINE.EQ.NPNT)MBNDEMP=IBAND
	ENDDO
	IF(MOD(MBNDFIL,2).NE.0)MBNDFIL=MBNDFIL-1
	IF(MOD(MBNDEMP,2).NE.0)MBNDEMP=MBNDEMP+1
	IF(MBNDFIL.LT.0)MBNDFIL=0
	MBNDFIL=MBNDFIL/2
	MBNDEMP=MBNDEMP/2
	ENDIF
	WRITE(IUN,1010)MBNDFIL
	WRITE(IUN,1020)MBNDEMP-MBNDFIL-1
1010    FORMAT(1X,'LR information: # of fully filled bands (nff) =',I4)
1020    FORMAT(1X,'LR information: # of bands crossing  EF (nef) =',I4)
	END
