	SUBROUTINE DELVEXTR(IGPTB,MY,IQPNT)
********************************************************
*  Set external perturbation to a single plane wave.   *
********************************************************
	IMPLICIT REAL*8 (A-C,E-H,O-Z)
	IMPLICIT COMPLEX*16 (D)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NRAD(NSORTMAX),INDGPTB(0:NENVMAX)
	COMPLEX*16 DPOT(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DBXC(0:NRADMAX,LMMAXV,NPAT,NSPINMAX),EXPQR,YLM(LMMAXV)
	DIMENSION SMT(NSORTMAX),ORTH(2:3),GPLW(3,0:NPLWMAX)
     &    ,H(NSORTMAX),R(0:NRADMAX,NSORTMAX)
     &    ,TAU(3,NPAT),QPNT(3),GPTB(3,0:NENVMAX)
     &    ,BES(0:LMAXV),BESD(0:LMAXV)
	CHARACTER TXTEL(NSORTMAX)*10
C Controls:
	COMMON /CONTROL/MAN,LMTO,NSPH,NINT                  !!! from readini
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from readini
        COMMON /SPIN/   NSPIN                               !!! from readini
C Inputs:
	COMMON /POTCOM/ SWZ,SMT                             !!! from readini
	COMMON /DENS/   RO                                  !!! from readscf
        COMMON /BASIS/  TAU                                 !!! from readstr
        COMMON /LATPAR/ PAR,ORTH,OMEGAC                     !!! from readini
        COMMON /QMESH/  NQPNT,QPNT                          !!! from qvector
        COMMON /PTBCOM/ NGSHL,NGPTB,GPTB,INDGPTB            !!! from qvector
C Change in thepotential:
	COMMON /DELPOT/ DPOT,DBXC                           !!! from delpot
C Radial mesh:
        COMMON /RADMESH/NRAD,H,R                            !!! from radmsh
C Plane waves:
        COMMON /PLWMESH/NPLW,GPLW                           !!! from plwmsh
C Outputs:
	COMMON /TXTEL/  TXTEL                               !!! from readini
	COMMON /UNIT/   IUN                                 !!! from readini
	DATA PI/3.141592653589793D0/
	IF(MY.EQ.-1.OR.MY.EQ.+1)RETURN
C  SET PERTURBATIVE MAGNETIC FIELD WITHIN MTS
        DO 1000 IATOM=1,NATOM          !!! over atoms
        ISORT=IS(IATOM)
        QX=(QPNT(1)+GPTB(1,IGPTB))*2.D0*PI/PAR
        QY=(QPNT(2)+GPTB(2,IGPTB))*2.D0*PI/PAR
        QZ=(QPNT(3)+GPTB(3,IGPTB))*2.D0*PI/PAR
        AQ=SQRT(QX**2+QY**2+QZ**2)
        IF(AQ.GE.1.D-10)THEN
        CALL SPHHARM(QX/AQ,QY/AQ,QZ/AQ,ILSV(ISORT),YLM)
        ELSE
        YLM(1)=1.D0/SQRT(4.D0*PI)
        DO LM=2,(ILSV(ISORT)+1)**2
        YLM(LM)=(0.D0,0.D0)
        ENDDO    
        ENDIF
        SCP=(QPNT(1)+GPTB(1,IGPTB))*TAU(1,IATOM)+
     &      (QPNT(2)+GPTB(2,IGPTB))*TAU(2,IATOM)+
     &      (QPNT(3)+GPTB(3,IGPTB))*TAU(3,IATOM)
        EXPQR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
        DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
        CALL BESSR(AQ*R(IRAD,ISORT),BES(0),BESD(0),ILSV(ISORT))
        DO L=0,ILSV(ISORT)             !!! over l
        DO M=-L,L                      !!! over m
        LM=L*(L+1)+M+1
C POLARIZATION "Z" - NON-ZERO MAGNETIC FIELD
	IF(MY.EQ. 0)DPOT(IRAD,LM,IATOM,NSPIN)=
     &  DPOT(IRAD,LM,IATOM,NSPIN)-4.D0*PI*BES(L)*
     &  EXPQR*DCONJG(YLM(LM))
	IF(MY.EQ. 0)DPOT(IRAD,LM,IATOM,1    )=
     &  DPOT(IRAD,LM,IATOM,1    )+4.D0*PI*BES(L)*
     &  EXPQR*DCONJG(YLM(LM))
C POLARIZATION "V" - NON-ZERO SCALAR POTENTIAL
	IF(MY.EQ. 2)DPOT(IRAD,LM,IATOM,NSPIN)=
     &  DPOT(IRAD,LM,IATOM,NSPIN)+4.D0*PI*BES(L)*
     &  EXPQR*DCONJG(YLM(LM))
	IF(MY.EQ. 2)DPOT(IRAD,LM,IATOM,1    )=
     &  DPOT(IRAD,LM,IATOM,1    )+4.D0*PI*BES(L)*
     &  EXPQR*DCONJG(YLM(LM))
        ENDDO                          !!! over m
        ENDDO                          !!! over l
        ENDDO                          !!! over radial mesh
1000	CONTINUE                       !!! over atoms
        END







	SUBROUTINE DELBEXTR(IGPTB,MY,IQPNT)
**************************************************************
*  Calculation of the external perturbation scaled by        *
*  exchange-correlation magnetic field.                      *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NRAD(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &   ,INDGPTB(0:NENVMAX)
	COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,V(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX),YLM(LMMAXV)
     &   ,DRHO(0:NRADMAX,LMMAXV,NPAT,NSPINMAX),EXPQR
     &   ,DMAG(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DPOT(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DBXC(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
	DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX),ORTH(2:3)
     &   ,WEIGHT(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &   ,SMT(NSORTMAX),RL(0:NRADMAX,0:LMAXV,NSORTMAX),TAU(3,NPAT)
     &   ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX),QPNT(3)
     &   ,BES(0:LMAXV),BESD(0:LMAXV),GPLW(3,0:NPLWMAX)
     &   ,GPTB(3,0:NENVMAX)
	LOGICAL SYM(LMMAXV,NPAT)
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NOVR,NPFR,MODE       !!! from readini
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from readini
	COMMON /ORBS/   NORBS                               !!! from readini
	COMMON /SPIN/   NSPIN                               !!! from readini
	COMMON /EXCH/   IXC                                 !!! from readini
C Inputs:
	COMMON /POTCOM/ SWZ,SMT,VSPH,V                      !!! from vfull
	COMMON /DENS/   RO                                  !!! from readscf
	COMMON /SYMMLM/ SYM,LMSYM        		    !!! from symmlm
	COMMON /BASIS/  TAU                                 !!! from readstr
        COMMON /LATPAR/ PAR,ORTH,OMEGAC                     !!! from readini
        COMMON /QMESH/  NQPNT,QPNT                          !!! from qvector
        COMMON /PTBCOM/ NGSHL,NGPTB,GPTB,INDGPTB            !!! from qvector
C Change in the potential:
	COMMON /DELPOT/ DPOT,DBXC                           !!! from delpot
C Change in charge density:
        COMMON /DELRO/  DRHO,DMAG                           !!! from delrho
C Radial mesh:
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL               !!! from radmsh
C Plane waves:
        COMMON /PLWMESH/NPLW,GPLW                           !!! from plwmsh
C Outputs:
	COMMON /UNIT/   IUN                                 !!! from readini
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
	IF(MY.EQ.0.OR.MY.EQ.2)RETURN
C  SET PERTURBATIVE MAGNETIC FIELD WITHIN MTS
        DO 1000 IATOM=1,NATOM          !!! over atoms
        ISORT=IS(IATOM)
        QX=(QPNT(1)+GPTB(1,IGPTB))*2.D0*PI/PAR
        QY=(QPNT(2)+GPTB(2,IGPTB))*2.D0*PI/PAR
        QZ=(QPNT(3)+GPTB(3,IGPTB))*2.D0*PI/PAR
        AQ=SQRT(QX**2+QY**2+QZ**2)
        IF(AQ.GE.1.D-10)THEN
        CALL SPHHARM(QX/AQ,QY/AQ,QZ/AQ,ILSV(ISORT),YLM)
        ELSE
        YLM(1)=1.D0/SQRT(4.D0*PI)
        DO LM=2,(ILSV(ISORT)+1)**2
        YLM(LM)=(0.D0,0.D0)
        ENDDO
        ENDIF
        SCP=(QPNT(1)+GPTB(1,IGPTB))*TAU(1,IATOM)+
     &      (QPNT(2)+GPTB(2,IGPTB))*TAU(2,IATOM)+
     &      (QPNT(3)+GPTB(3,IGPTB))*TAU(3,IATOM)
        EXPQR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
        DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
        CALL BESSR(AQ*R(IRAD,ISORT),BES(0),BESD(0),ILSV(ISORT))
        DO L=0,ILSV(ISORT)             !!! over l
        DO M=-L,L                      !!! over m
        LM=L*(L+1)+M+1
C POLARIZATION "+/-" 
        IF(MY.EQ.-1)THEN
        DMAG(IRAD,LM,IATOM,1    )=(0.D0,0.D0)
        DMAG(IRAD,LM,IATOM,NSPIN)=4.D0*PI*BES(L)*EXPQR*
     &  DCONJG(YLM(LM))
        ELSEIF(MY.EQ.+1)THEN
        DMAG(IRAD,LM,IATOM,NSPIN)=(0.D0,0.D0)
        DMAG(IRAD,LM,IATOM,1    )=4.D0*PI*BES(L)*EXPQR*
     &  DCONJG(YLM(LM))
	ENDIF
        ENDDO                          !!! over m
        ENDDO                          !!! over l
        ENDDO                          !!! over radial mesh
1000    CONTINUE                       !!! over atoms
	CALL DELBEXCH(IGPTB,MY,IQPNT,2)!!! change in XC-magnetic field
	END
