        SUBROUTINE INIT
*************************************************************
*  Control module <INIT> for reading all the input data     *
*************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER NQDIV(3)
        DIMENSION QPNT(3)
        CHARACTER*60 INIFILE,SC0FILE,STRFILE,LRTFILE,INPFOLD
        CHARACTER TEXQ*10,TEXM*60,TEXOM*10,TASK*10
     &    ,TXTEL(NSORTMAX)*10,TXTSP(2)*2
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPFR,MODE          !!! from init
        COMMON /QMESH/  NQPNT,QPNT,NUMQ,NQDIV,KEYQ             !!! from init
	COMMON /PTBCOM/ NGSHL                                  !!! from init
	COMMON /FREQU/  OMGR                                   !!! from init
        COMMON /TXTEL/  TXTEL,TXTSP,TEXQ,TEXM,TASK,TEXOM       !!! from init
	COMMON /INP0/   INIFILE,SC0FILE,STRFILE,LRTFILE,INPFOLD!!! from init
	COMMON /UNIT/   IUN,IUT,IUR
	CALL SETUP               !!! initilazes variables
        CALL PHEAD(IUT)          !!! prints title
	CALL CHANN               !!! channel description
C  READ INPUT FOLDER,DEFAULT IS "INP/"
        WRITE(IUT,1010)
        READ(IUR,1000)INPFOLD
        NF=INDEX(INPFOLD,' ')
        IF(NF.EQ.1)INPFOLD(1:4)='INP/'
        IF(NF.EQ.1)NF=5
        NF=INDEX(INPFOLD,' ')
C  READ INIFILE-NAME,DEFAULT IS "ini"
        WRITE(IUT,1020)
        READ(IUR,1000)INIFILE
        NB=INDEX(INIFILE,' ')
        IF(NB.EQ.1)INIFILE(1:3)='ini'
        IF(NB.EQ.1)NB=4
        INIFILE=INPFOLD(1:NF-1)//INIFILE(1:NB-1)
C  READ SCFFILE-NAME,DEFAULT IS "sc0"
        WRITE(IUT,1030)
        READ(IUR,1000)SC0FILE
        NB=INDEX(SC0FILE,' ')
        IF(NB.EQ.1)SC0FILE(1:3)='sc0'
        IF(NB.EQ.1)NB=4
        SC0FILE=INPFOLD(1:NF-1)//SC0FILE(1:NB-1)
C  READ STRFILE-NAME,DEFAULT IS "str"
        WRITE(IUT,1040)
        READ(IUR,1000)STRFILE
        NB=INDEX(STRFILE,' ')
        IF(NB.EQ.1)STRFILE(1:3)='str'
        IF(NB.EQ.1)NB=4
        STRFILE=INPFOLD(1:NF-1)//STRFILE(1:NB-1)
C  READ LRTFILE-NAME,DEFAULT IS "lrt"
        WRITE(IUT,1050)
        READ(IUR,1000)LRTFILE
        NB=INDEX(LRTFILE,' ')
        IF(NB.EQ.1)LRTFILE(1:3)='lrt'
        IF(NB.EQ.1)NB=4
        LRTFILE=INPFOLD(1:NF-1)//LRTFILE(1:NB-1)
C  SET Q-VECTOR NUMBER
        WRITE(IUT,1060)
        READ(IUR,1000)TEXQ
        NQ=INDEX(TEXQ,' ')
        IF(NQ.NE.1)READ(TEXQ,*)NUMQ
        IF(NQ.EQ.1)NUMQ=1
C  SET # OF G-SHELLS
        WRITE(IUT,1070)
        READ(IUR,*)NGSHL
C  SET FREQUENCY
        WRITE(IUT,1080)
        READ(IUR,1000)TEXOM
        NO=INDEX(TEXOM,' ')
        IF(NO.NE.1)READ(TEXOM,*)NUMOM
        IF(NO.EQ.1)NUMO=0
	OMGR=DBLE(NUMOM)/1000.D0/13.6058D0
C  SET RUN MODE
C       =0 - preparational, 1 - full start, 2 - restart,
C        4 - susceptibility calculation
        WRITE(IUT,1090)
        READ(IUR,*)MODE
C  SET POLARIZATION FOR PARALLEL COMPUTATION
        WRITE(IUT,1100)
        READ(IUR,1000)TEXM
C  READ CONTROL DATA
	CALL READINI          !!! reads input control file
	CALL READLRT          !!! reads linear response set-up
	CALL READSCF          !!! reads charge density distribution
	CALL READSTR          !!! reads structure data
	CALL MAGFILE          !!! sets file storage
        CALL RUNTASK          !!! specify polarization
        CALL QVECTOR          !!! reads perturbation vector
C  TEST DATA
	CALL TESTINP          !!! tests array bounds
        CALL PRININI          !!! prints INIFILE    
        CALL PRINLRT          !!! prints LRTFILE
	CALL PRINSTR          !!! prints STRFILE      
C  PREPARE DATA
        CALL ASAMSH           !!! prepares radial mesh
        CALL FFTMSH           !!! generates FFT-grid
        CALL PLWMSH           !!! generates plane waves
        CALL SETPAR           !!! sets decay constants for Gaussians
        CALL TEIPAR           !!! select plane waves for Teilor series
        CALL PLWSTR           !!! distorts plane waves after strain
        CALL PLW2MH           !!! integrates plane waves over int.region
C  READ OTHER DATA
        CALL READHUB          !!! read HUBFILE
1000    FORMAT(A)
1010    FORMAT(1X,'IFOLDER? ',$)
1020    FORMAT(1X,'INIFILE? ',$)
1030    FORMAT(1X,'SCFFILE? ',$)
1040    FORMAT(1X,'STRFILE? ',$)
1050    FORMAT(1X,'LRTFILE? ',$)
1060    FORMAT(1X,'Q-POINT? ',$)
1070    FORMAT(1X,'G-SHELL? ',$)
1080    FORMAT(1X,'FREQUEN? ',$)
1090    FORMAT(1X,'RUNMODE? ',$)
1100    FORMAT(1X,'RUNTASK? ',$)
	END
