	SUBROUTINE MAGNONS
************************************************************
*   The calculation of spin susceptibility.                * 
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER NITER(-1:2)
	CHARACTER ST*8,FN*8,TEXT*64,TXTEL(NSORTMAX)*10,POL(-1:2)*3
	DIMENSION QPNT(3)
	COMMON /CONTROL/LIFT                                 !!! from init
	COMMON /QMESH/  NQPNT,QPNT                           !!! from init
	COMMON /MAGCOM/ ITERMAX,NITER                        !!! from init
	COMMON /TEXT/   TEXT                                 !!! from init
	COMMON /TXTEL/  TXTEL                                !!! from init
	COMMON /UNIT/   IUN                                  !!! from init
	LOGICAL EXIT
	DATA ST/'started'/,FN/'finished'/,POL/'"m"','"z"','"p"','"v"'/
	IQPNT=1
	WRITE(IUN,1010)TEXT
C  PREPARE DATA WHICH DEPEND ON THE CRYSTALLINE STRUCTURE
	call timel(times)
	write(iun,1000)st,times
	CALL DELMSH(IQPNT)         !!! analisys of k-mesh in IBZ
	CALL DELMSW(IQPNT)         !!! set fine k-mesh in IBZ
	CALL CHITET(IQPNT)         !!! k-point tetrahedron weights 
	CALL PRINTQ(IQPNT)         !!! print susceptibility 
	call timel(timef)
	write(iun,1000)fn,timef
	IF(LIFT.LE.3)CALL OUTPUT('No SCF-loop',IQPNT)
C  CALCULATE POLARIZABILITY FUNCTION
        call timel(times)
        write(iun,1001)st,times
   	CALL PLWCRD(IQPNT)         !!! set G-vectors for pi(r,q+G)
CCC     CALL POLARZ(IQPNT)         !!! polarizability pi(r,q+G) [G input]
CCC     CALL PLZMAT(IQPNT)         !!! matrix in plane-wave representation
CCC     CALL SCREEN(IQPNT)         !!! inverse dielectric matrix
        call timel(timef)
        write(iun,1001)fn,timef
C  CALCULATE STONER ENHANCEMENT FACTOR
        call timel(times)
        write(iun,1002)st,times
CCC     CALL STNBND(IQPNT)         !!! response to the magnetic moment
CCC     CALL STONER(IQPNT)         !!! generalized Stoner matrix
        call timel(timef)
        write(iun,1002)fn,timef
C  SET CHANGE IN CHARGE DENSITY AT THE BEGINING
	CALL PLWPTB(IQPNT)         !!! set plane waves for the perturbation
        CALL SPLDRO(IQPNT)         !!! spline induced density to a new mesh
   	CALL MIXDRO(IQPNT,0,EXIT)  !!! initialize induced density in MTS
C
C ******* THE LOOP OF SELF-CONSISTENCY FOR GIVEN Q-VECTOR ******
C
	DO 100 ITER=1,ITERMAX
	WRITE(IUN,1020)ITER,(QPNT(I),I=1,3)
        CALL MIXBRD(IQPNT,ITER,1)  !!! initialize Broyden mixing
	CALL MIXSTN(IQPNT,ITER,1)  !!! initialize Broyden mixing
        CALL MIXHUB(IQPNT,ITER,1)  !!! initialize Broyden mixing
C  CALCULATE FULL POTENTIAL VARIATION
	call timel(times)
	write(iun,1003)st,times
   	CALL SDELPOT(IQPNT,ITER)   !!! set change in the potential
	call timel(timef)
	write(iun,1003)fn,timef
C  CALCULATE POTENTIAL PARAMETERS VARIATION, 
C  FIND INDUCED CHARGE DENSITY
	call timel(times)
	write(iun,1004)st,times
   	CALL DELBND(IQPNT)         !!! Change in pot.par and TOS
	call timel(timef)
	write(iun,1004)fn,timef
C  ADD PART CONNECTED WITH THE LONG-RANGE POTENTIAL
        call timel(times)
        write(iun,1005)st,times
        CALL SSCRPOT(IQPNT,ITER)   !!! compute long-range contribution
        call timel(timef)
        write(iun,1005)fn,timef
C  COMPUTE SUSCEPTIBILITY
        call timel(times)
        write(iun,1006)st,times
        CALL CHIMAT(IQPNT)         !!! compute susceptibility matrix
        call timel(timef)
        write(iun,1006)fn,timef
	CALL MIXBRD(IQPNT,ITER,2)  !!! mix densities according to Broyden
       	CALL MIXDRO(IQPNT,ITER,EXIT)!! mix densities with linear mixing
	CALL MIXSTN(IQPNT,ITER,2)  !!! mix magnetic moments
        CALL MIXHUB(IQPNT,ITER,2)  !!! mix occupancies
	IF(EXIT)CALL OUTPUT('Density convergence reached',IQPNT)
 100    CONTINUE
	CALL OUTPUT('Number of iterations exceeded',IQPNT)
1000  FORMAT('******* CHITET ',A8,' ; CPU time: ',G14.7,' ************')
1001  FORMAT('******* POLARZ ',A8,' ; CPU time: ',G14.7,' ************')
1002  FORMAT('******* STONER ',A8,' ; CPU time: ',G14.7,' ************')
1003  FORMAT('******* DELPOT ',A8,' ; CPU time: ',G14.7,' ************')
1004  FORMAT('******* DELBND ',A8,' ; CPU time: ',G14.7,' ************')
1005  FORMAT('******* SCRPOT ',A8,' ; CPU time: ',G14.7,' ************')
1006  FORMAT('******* CHIMAT ',A8,' ; CPU time: ',G14.7,' ************')
1010  FORMAT(/1X,A64/)
1020  FORMAT(/63('=')/
     &1X,'ITERATION ',I3,'  FOR Q-VECTOR (',G11.4,',',G11.4,',',
     &  G11.4,')'/63('=')/)
	END
