	SUBROUTINE RUNGE(ENY,AFIS,AFIPS,DNY,TNY,DNYP,FPMN,S
     &                  ,Z,LM,NRAD,H,R,DR,LR)
************************************************************
*   The calculation of potential parameters for <<LMTO>>   *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	DIMENSION Z(0:NRADMAX),FI(0:NRADMAX,5),FID(0:NRADMAX,5)
     &   ,AFI  (0:NRADMAX,0:LMAXT),AFID  (0:NRADMAX,0:LMAXT)
     &   ,AFIP (0:NRADMAX,0:LMAXT),AFIDP (0:NRADMAX,0:LMAXT)
     &   ,AFIPP(0:NRADMAX,0:LMAXT),AFIDPP(0:NRADMAX,0:LMAXT)
     &   ,AFIS(0:LMAXT),AFIPS(0:LMAXT),ENY(0:LMAXT),R(0:NRADMAX)
     &   ,DNY(0:LMAXT),DNYP(0:LMAXT),FPMN(0:LMAXT),DR(0:NRADMAX)
     &   ,AFIDDS(0:LMAXT),AFIDDPS(0:LMAXT),TNY(0:LMAXT)
	COMPLEX*16 DELFI(0:NRADMAX,5),DELFID(0:NRADMAX,5),DELNY
     &   ,DVL(0:NRADMAX)
	DATA DEL/0.025D0/,PI/3.141592653589793D0/
	DELNY=(0.D0,0.D0)
	SQPI4=SQRT(4.D0*PI)
	DO 10 IRAD=0,NRAD
	DVL(IRAD)=DCMPLX(-SQPI4,0.D0)
  10	CONTINUE
C  *** DO GLOBALLY OVER L UP TO LMAX ***
	DO 40 L=0,LM
C  SOLVE RADIAL SCHROEDINGER EQUATION 
	CALL RADSCH(ENY(L),S,Z,L,NODES,D,FI(0,3),FID(0,3),NRAD,
     &  H,R,DR,LR)
C  SOLVE SCHROEDINGER EQUATION FOR ENERGY DERIVATIVE
	CALL DRADSCH(ENY(L),DELNY,S,Z,L,DVL,NOD,DELFI(0,3),
     &  DELFID(0,3),FI(0,3),FID(0,3),NRAD,H,R,DR,LR)
C  SET POTENTIAL PARAMETERS AT THE SPHERE BOUNDARY
	AFIS(L)=FI(NRAD,3) 
	AFIDS=FID(NRAD,3)
	AFIPS(L)=DREAL(DELFI(NRAD,3))
C	AFIDPS=DREAL(DELFID(NRAD,3))
	DNY(L)=S*AFIDS/AFIS(L)
	TNY(L)=NODES+0.5D0-ATAN(DNY(L))/PI
C	DE=S*AFIDPS/AFIPS
	DNYP(L)=DNY(L)-1.D0/(S*AFIS(L)*AFIPS(L))
	DO 20 IRAD=0,NRAD
	FI(IRAD,3)=DREAL(DELFI(IRAD,3))*R(IRAD)
  20	CONTINUE
	FPMN(L)=FSIM(FI(0,3),FI(0,3),NRAD,H,DR)
  30	CONTINUE
  40	CONTINUE
	RETURN


	ENTRY CT(E,T,TE,L1,S,Z,NRAD,H,R,DR,LR)
*********************************************************
*   The calculation of T(D(E))-function for given L,E   *
*********************************************************
        EN=E
	L=L1-1
	CALL RADSCH(EN,S,Z,L,NODES,D,FI(0,3),FID(0,3),NRAD,H,R,DR,LR)
	T=NODES+0.5D0-ATAN(D)/PI
	DE=-1.D0/(S*FI(NRAD,3)*FI(NRAD,3))
	TE=-1.D0/(1+D*D)/PI*DE
	RETURN


	ENTRY DFIFID(ENY,AFI,AFIP,AFID,AFIDP,AFIDDS,AFIDDPS,
     &  S,Z,LM,NRAD,H,R,DR,LR)
*********************************************************
*   The calculation of the radial wave functions        *
*   and their energy derivatives up to first order.     *
*********************************************************
	DELNY=(0.D0,0.D0)
	SQPI4=SQRT(4.D0*PI)
	DO 50 IRAD=0,NRAD
	DVL(IRAD)=DCMPLX(-SQPI4,0.D0)
  50	CONTINUE
	DO 80 L=0,LM
C  SOLVE RADIAL SCHROEDINGER EQUATION 
	CALL RADSCH(ENY(L),S,Z,L,NODES,D,FI(0,3),FID(0,3),NRAD,
     &  H,R,DR,LR)
C  SOLVE SCHROEDINGER EQUATION FOR ENERGY DERIVATIVE
	CALL DRADSCH(ENY(L),DELNY,S,Z,L,DVL,NOD,DELFI(0,3),
     &  DELFID(0,3),FI(0,3),FID(0,3),NRAD,H,R,DR,LR)
	DO 60 IRAD=0,NRAD
	AFI(IRAD,L)=FI(IRAD,3)
	AFID(IRAD,L)=FID(IRAD,3)
	AFIP(IRAD,L)=DREAL(DELFI(IRAD,3))
	AFIDP(IRAD,L)=DREAL(DELFID(IRAD,3))
  60	CONTINUE
C  SECOND ORDER DERIVATIVES AT THE SPHERE BOUNDARY
	AFIDDS(L)=0.D0
	AFIDDPS(L)=0.D0
C	AFIDDS(L)=AFI(NRAD,L)*(L*(L+1)/S/S-Z(NRAD)/S-ENY(L))
C     &  	      -2.D0/S*AFID(NRAD,L)
C	AFIDDPS(L)=AFIP(NRAD,L)*(L*(L+1)/S/S-Z(NRAD)/S-ENY(L))
C     &  	      -2.D0/S*AFIDP(NRAD,L)-AFI(NRAD,L)
  80	CONTINUE
	RETURN


	ENTRY PFIFIP(ENY,AFI,AFIP,AFID,AFIDP,AFIPP,AFIDPP,
     &  S,Z,LM,NRAD,H,R,DR,LR)
*********************************************************
*   The calculation of the radial wave functions        *
*   and their energy derivatives up to second order.    *
*********************************************************
	DELNY=(0.D0,0.D0)
	SQPI4=SQRT(4.D0*PI)
	DO 90 IRAD=0,NRAD
	DVL(IRAD)=DCMPLX(-SQPI4,0.D0)
  90	CONTINUE
	DO 120 L=0,LM
	DO 100 N=1,5
	EN=ENY(L)+DEL*(N-3.D0)
C  SOLVE RADIAL SCHROEDINGER EQUATION 
	CALL RADSCH(EN,S,Z,L,NODE,D,FI(0,N),FID(0,N),NRAD,
     &  H,R,DR,LR)
	IF(N.EQ.3)NODES=NODE
C  SOLVE SCHROEDINGER EQUATION FOR ENERGY DERIVATIVE
	CALL DRADSCH(EN,DELNY,S,Z,L,DVL,NOD,DELFI(0,N),
     &  DELFID(0,N),FI(0,N),FID(0,N),NRAD,H,R,DR,LR)
 100	CONTINUE
	DO 110 IRAD=0,NRAD
	AFI(IRAD,L)=FI(IRAD,3)
	AFID(IRAD,L)=FID(IRAD,3)
	AFIP(IRAD,L)=DREAL(DELFI(IRAD,3))
	AFIDP(IRAD,L)=DREAL(DELFID(IRAD,3))
        AFIPP(IRAD,L)=DREAL((DELFI(IRAD,1)-DELFI(IRAD,5)+8.D0*
     &  (DELFI(IRAD,4)-DELFI(IRAD,2))))/(12.D0*DEL)
        AFIDPP(IRAD,L)=DREAL((DELFID(IRAD,1)-DELFID(IRAD,5)+8.D0*
     &  (DELFID(IRAD,4)-DELFID(IRAD,2))))/(12.D0*DEL)
 110	CONTINUE
 120	CONTINUE
	RETURN
	END


	SUBROUTINE RADSCH(EN,S,Z,L,NODES,D,FI,FID,NRAD,H,R,DR,LR)
***************************************************************
*  The solution of the radial Schroedinger equation           *
*                                                             *
*   / P'(r)=Q(r)+(l+1)*P(r)/r                                 *
*   \ Q'(r)=(V(r)-E)*P(r)-(l+1)*Q(r)/r                        *
*     FI(r)=P(r)/r and FID(r)=FI'(r)                          *
*                                                             *
*  or scalar-relativistic Dirac equation                      *
*                                                             *
*   / P'(r)=A(r)*Q(r)+P(r)/r                                  *
*   \ Q'(r)=(V(r)-E+C(r))*P(r)-Q(r)/r                         *
*  where                                                      *
*     A(r)=1+(E-V(r))/c^2                                     *
*     C(r)=l*(l+1)/r^2/A(r)                                   *
*     FI(r)=P(r)/r and FID(r)=FI'(r)                          *
*  and c is the light velocity                                *
***************************************************************
	IMPLICIT REAL*8 (A-H,K,M,O-Z)
	INCLUDE 'PARAM.DAT'
	REAL*8 L2
	DIMENSION Z(0:NRADMAX),P(0:NRADMAX),Q(0:NRADMAX),R(0:NRADMAX)
     &   	 ,FI(0:NRADMAX),FID(0:NRADMAX),DR(0:NRADMAX)
	DATA C2/0.000013312838D0/
	L1=L+1
	NODES=0
	BETTA=S/(EXP(H*NRAD)-1.D0)
	IF(Z(0).GE.1.D-05)LCR=LR
	IF(Z(0).LE.1.D-05)LCR=0
C ****** NON-RELATIVISTIC VERSION (LOGARITHMIC SCALE) ******
	IF(LCR.EQ.0) THEN
C   ASSYMPTOTIC BEHAVIOR ::
        P(0)=0.D0
	Q(0)=0.D0
	I0=1
   1	P(I0)=R(I0)**L1*(1.D0-Z(0)/(2.D0*L1)*R(I0))
	IF(P(I0).EQ.0.D0)THEN
	Q(I0)=0.D0
	I0=I0+1
	GOTO1
	ENDIF
        Q(I0)=-Z(0)*R(I0)**L1/(L1*2.D0)
        IF(Z(0).LE.1.D-05)Q(I0)=-EN*R(I0)**(L1+1)/(2.D0*L1+1)
C   4-TH ORDER RUNGE-KUTTA LOOP ::
	R3=R(I0)
	A3=DR(I0)*H
	B3=A3/R3*L1
	V3=A3*EN+A3/R3*Z(I0)
        DO 10 I=I0,NRAD-1
	R1=R3
	R2=BETTA*(EXP(H*(I+0.5D0))-1.D0) !!! R(I+1/2)
	R3=R(I+1)
        A1=A3
	A2=(R2+BETTA)*H
	A3=DR(I+1)*H
        B1=B3
        B2=A2/R2*L1
        B3=A3/R3*L1
        V1=V3
        IF(I.NE.NRAD-1)V2=A2*EN+A2/R2*(9.D0*(Z(I)+Z(I+1))-Z(I-1)-Z(I+2))
     &  *6.25D-2
	IF(I.EQ.NRAD-1)V2=A2*EN+A2/R2*(Z(I)+Z(I+1))*0.5D0
        V3=A3*EN+A3/R3*Z(I+1)
C   **************
	K1= A1*Q(I)+B1*P(I)
	M1=-V1*P(I)-B1*Q(I)
C   **************
	K2= A2*(Q(I)+M1*0.5D0)+B2*(P(I)+K1*0.5D0)
	M2=-V2*(P(I)+K1*0.5D0)-B2*(Q(I)+M1*0.5D0)
C   **************
	K3= A2*(Q(I)+M2*0.5D0)+B2*(P(I)+K2*0.5D0)
	M3=-V2*(P(I)+K2*0.5D0)-B2*(Q(I)+M2*0.5D0)
C   **************
	K4= A3*(Q(I)+M3)+B3*(P(I)+K3)
	M4=-V3*(P(I)+K3)-B3*(Q(I)+M3)
C   **************
	P(I+1)=P(I)+(K1+K4+2.D0*(K2+K3))/6.D0
	Q(I+1)=Q(I)+(M1+M4+2.D0*(M2+M3))/6.D0
	IF(P(I)*P(I+1).LT.0.D0)NODES=NODES+1
  10	CONTINUE
	D=S*Q(NRAD)/P(NRAD)+L  !!! LOGARITHM.DERIVATIVE
C   NORMALISATION ::
	ANORM=SQRT(FSIM(P(0),P(0),NRAD,H,DR(0)))
        DO 20 I=1,NRAD
	FI(I)=P(I)/(ANORM*R(I))
	FID(I)=Q(I)/(ANORM*R(I))+L*P(I)/(ANORM*R(I)*R(I))
  20	CONTINUE
	IF(L.EQ.0)THEN
	FI(0)=1.D0/ANORM
	FID(0)=-Z(0)/(2.D0*ANORM)
	ELSEIF(L.EQ.1)THEN
	FI(0)=0.0D0
	FID(0)=1.D0/ANORM
	ELSE
	FI(0)=0.D0
	FID(0)=0.D0
	ENDIF
C ****** RELATIVISTIC VERSION ******
	ELSEIF(LCR.EQ.1)THEN
	L2=L1*(L1-1)
C   ASSIMPTOTIC BEHAVIOR ::
	QL=SQRT(L2+1-Z(0)**2*C2)
        P(0)=0.D0
	Q(0)=0.D0
	I0=1
  21	P(I0)=R(I0)**QL
	IF(P(I0).EQ.0.D0)THEN
	Q(I0)=0.D0
	I0=I0+1
	GOTO21
	ENDIF
        Q(I0)=P(I0)*(QL-1)/(Z(0)*C2)
C   4-TH ORDER RUNGE-KUTTA LOOP ::
	R3=R(I0)
	B3=DR(I0)/R3*H
	EV3=EN+Z(I0)/R3
	A3=DR(I0)*(1.D0+EV3*C2)*H
	V3=DR(I0)*(EV3-L2/R3/R3/(1.D0+EV3*C2))*H
	DO 30 I=I0,NRAD-1
	R1=R3
	R2=BETTA*(EXP(H*(I+0.5D0))-1.D0)   !!! R(I+1/2)
	R3=R(I+1)
	B1=B3
	B2=(R2+BETTA)/R2*H
	B3=DR(I+1)/R3*H
	EV1=EV3
	IF(I.NE.NRAD-1) EV2=EN+(9.D0*(Z(I)+Z(I+1))-Z(I-1)-Z(I+2))*
     &  6.25D-02/R2
	IF(I.EQ.NRAD-1) EV2=EN+(Z(I)+Z(I+1))*0.5D0/R2
	EV3=EN+Z(I+1)/R3
	A1=A3
	A2=(R2+BETTA)*(1.D0+EV2*C2)*H
	A3=DR(I+1)*(1.D0+EV3*C2)*H
	V1=V3
	V2=(R2+BETTA)*(EV2-L2/R2/R2/(1.D0+EV2*C2))*H
	V3=DR(I+1)*(EV3-L2/R3/R3/(1.D0+EV3*C2))*H
C   **************
	K1= A1*Q(I)+B1*P(I)
	M1=-V1*P(I)-B1*Q(I)
C   **************
	K2= A2*(Q(I)+M1*0.5D0)+B2*(P(I)+K1*0.5D0)
	M2=-V2*(P(I)+K1*0.5D0)-B2*(Q(I)+M1*0.5D0)
C   **************
	K3= A2*(Q(I)+M2*0.5D0)+B2*(P(I)+K2*0.5D0)
	M3=-V2*(P(I)+K2*0.5D0)-B2*(Q(I)+M2*0.5D0)
C   **************
	K4= A3*(Q(I)+M3)+B3*(P(I)+K3)
	M4=-V3*(P(I)+K3)-B3*(Q(I)+M3)
C   **************
	P(I+1)=P(I)+(K1+K4+2.D0*(K2+K3))/6.D0
	Q(I+1)=Q(I)+(M1+M4+2.D0*(M2+M3))/6.D0
	IF(P(I)*P(I+1).LT.0.D0)NODES=NODES+1
  30	CONTINUE
	D=Q(NRAD)/P(NRAD)*(S+(EN*S+Z(NRAD))*C2)
C   NORMALISATION ::
	ANORM=SQRT(FSIM(P(0),P(0),NRAD,H,DR))
        DO 40 I=1,NRAD
	FI (I)=P(I)/(ANORM*R(I))
	FID(I)=Q(I)/(ANORM*R(I))*(1.D0+C2*(EN+Z(I)/R(I)))
  40	CONTINUE
	IF(L.EQ.0)THEN
	FI(0)=FI(1)-FID(1)*R(1)  !!! diverges
	FID(0)=FID(1)
	ELSEIF(L.EQ.1)THEN
	FI(0)=0.D0
	FID(0)=FID(1)            !!! diverges
	ELSE
	FI(0)=0.D0
	FID(0)=0.D0
	ENDIF
	ENDIF
	END

C********* INTEGRATION PROGRAM ***************
	FUNCTION FSIM(T1,T2,NRAD,H,DR)
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	DIMENSION T1(0:NRADMAX),T2(0:NRADMAX),DR(0:NRADMAX)
	S4=4.D0*DR(1)*T1(1)*T2(1)
	S2=DR(0)*T1(0)*T2(0)+DR(NRAD)*T1(NRAD)*T2(NRAD)
	DO 10 J=2,NRAD-2,2
	S2=S2+2.D0*DR(J)*T1(J)*T2(J)
	S4=S4+4.D0*DR(J+1)*T1(J+1)*T2(J+1)
10	CONTINUE
	FSIM=H*0.333333333333333333D0*(S2+S4)
	RETURN
	END
