	SUBROUTINE ENSEARCH(X1,Y0,X0,ISORT,L,ISPIN)
*************************************************************
*  Searchs for Eny value by iterative procedure.            *
*************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER LR(NSORTMAX),NRAD(NSORTMAX)
	DIMENSION VSPH(0:NRADMAX,NSORTMAX,NSPINMAX)
     &   ,SMT(NSORTMAX),STEP(NSORTMAX),R(0:NRADMAX,NSORTMAX)
     &   ,DR(0:NRADMAX,NSORTMAX)
	LOGICAL LEFT,RIGHT
C Controls
	COMMON /SPIN/    NSPIN                                !!! from readini
	COMMON /RELATIV/ LR                                   !!! from readini
C Inputs:
	COMMON /COMCENY/ ITMAX,EPS,H                          !!! from setup
	COMMON /POTCOM/  SWZ,SMT,VSPH                         !!! from vfull
C Rad.mesh:
	COMMON /RADMESH/ NRAD,STEP,R,DR                       !!! from radmsh
C Internal:
	COMMON /LTRT/X,YY,DY,XL,YYL,DYL,LEFT,XR,YYR,DYR,RIGHT
C THE AUXILIARY FUNCTION OF THE PARABOLA METHOD IN TWO
C DIFFERENT FORMS.
	F1(A,B)=2.D0*A/(1.D0+SQRT(1.D0+4.D0*A*(B-1.D0)))
	F2(C,D)=2.D0/(C+SQRT(C*C+4.D0*(D-C)))
C
C INITIATION
	ITER=1
	H1=1.D0/H
	X=X1
	LEFT=.FALSE.
	RIGHT=.FALSE.
C  BEGIN ITERATION LOOP
1       CALL CT(X,Y,DY,L,SMT(ISORT),VSPH(0,ISORT,ISPIN),NRAD(ISORT),
     &  STEP(ISORT),R(0,ISORT),DR(0,ISORT),LR(ISORT))
C	DY=DY/DX
	YY=Y-Y0
C	PRINT*,'ITER,X,YY',ITER,X,YY  !!!DEBUGGING
	CALL SLTRT
	IF(.NOT.LEFT.OR..NOT.RIGHT) THEN
C	THE NEWTON'S METHOD.
	  IF(DY.LE.ABS(YY*H1)) X=X-SIGN(H,YY)
C		WITH LIMITATION
	  IF(DY.GT.ABS(YY*H1)) X=X-YY/DY
C		WITHOUT LIMITATION
	ELSE IF(LEFT.AND.RIGHT) THEN
C  PARABOLA METHOD.
	  DELTX=XR-XL
	  IF(ABS(DELTX).LE.EPS)GOTO 2
	  DYS=(YYR-YYL)/DELTX
	  IF(ABS(YYL).LE.YYR) THEN
	    ALFA=ABS(YYL/DELTX)
	    IF(ALFA.LE.DYL) THEN
	      A=ALFA/DYL
	      B=DYS/DYL
	      X=XL+DELTX*F1(A,B)
	    ELSE
	      C=DYL/ALFA
	      D=DYS/ALFA
	      X=XL+DELTX*F2(C,D)
	    END IF
	  ELSE
	    BETA=YYR/DELTX
	    IF(BETA.LE.DYR) THEN
	      A=BETA/DYR
	      B=DYS/DYR
	      X=XR-DELTX*F1(A,B)
	    ELSE
	      C=DYR/BETA
	      D=DYS/BETA
	      X=XR-DELTX*F2(C,D)
	    END IF
	  END IF
	END IF
C  EXITS
	IF(ITER.GE.ITMAX)THEN
	PRINT*,' THE EXCEEDING OF ITMAX IN ENSEARCH'
	PRINT*,' DELTA_ENY=',DELTX
	GOTO 2
	ENDIF
	IF(ABS(YY).LE.EPS) GO TO 2
	ITER=ITER+1
	GO TO 1
C  END LOOPING
2	IF(ITER.NE.1)THEN
	 X0=X
	ELSE
	 X0=X1
	ENDIF
	RETURN
	END


	SUBROUTINE SLTRT
*************************************************************
*  CLASSIFIES X INTO LEFT AND RIGHT POINTS.                 *
*************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL LEFT,RIGHT
	COMMON/LTRT/X,YY,DY,XL,YYL,DYL,LEFT,XR,YYR,DYR,RIGHT
	IF(YY.LE.0.) THEN
	  XL=X
	  YYL=YY
	  DYL=DY
	  LEFT=.TRUE.
	ELSE
	  XR=X
	  YYR=YY
	  DYR=DY
	  RIGHT=.TRUE.
	END IF
	RETURN
	END

