	SUBROUTINE SSETENY(IPAN)
****************************************************************
*  Subroutine  finds optimal energy centers of linearization.  *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NHSORT(NSORTMAX),IS(NPAT),NRAD(NSORTMAX),NKAP(NPANMAX)
     &   ,NODES(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX),LR(NSORTMAX)
     &   ,MNY  (0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX),INC(NKAPMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,LNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,NCLS(0:LMAXT,NSORTMAX,NPANMAX)
	DIMENSION DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,DHLOG(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,R(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &   ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX),H(NSORTMAX)
     &   ,SMT(NSORTMAX),APHI(0:NRADMAX),APHID(0:NRADMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	CHARACTER TXTEL(NSORTMAX)*10
C Controls:
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from readini
	COMMON /SPIN/   NSPIN                                !!! from readini
	COMMON /RELATIV/LR                                   !!! from readini
C Inputs:
	COMMON /KAPPAR/ NPAN,NKAP                            !!! from readini
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from readini
	COMMON /INPPAR/ TNY,ENY,DNY,NODES,MNY,DHLOG,NCLS,LNY !!! from seteny
	COMMON /POTCOM/ SWZ,SMT,VSPH                         !!! from vfull
C Rad.mesh:
	COMMON /RADMESH/NRAD,H,R,DR                          !!! from radmesh
C Outputs:
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /TXTEL/  TXTEL                                !!! from init
	DATA PI/3.141592653589793D0/
	IF(IPAN.NE.1)RETURN
	DO 2000 ISPIN=1,NSPIN                                !!! over ispin
	DO 1000 ISORT=1,NSORT                                !!! over isort
	DO IKAP=1,NKAP(IPAN)                                 !!! over ikap
	DO L=0,ILSB(ISORT)                                   !!! over l
	IF(MNY(L,ISORT,IKAP,IPAN).EQ.1.OR.
     &  MNY(L,ISORT,IKAP,IPAN).EQ.3)THEN
C  TRANSFERE TO CONVINIET FUNCTION TNY DEPENDING ON DNY AND # OF NODES
	TNY(L,ISORT,IKAP,IPAN,ISPIN)=0.5D0+NODES(L,ISORT,IKAP,IPAN)-
     &  ATAN(DNY(L,ISORT,IKAP,IPAN,ISPIN))/PI
C  FIND ENY-ENERGY
	CALL ENSEARCH(ENY(L,ISORT,IKAP,IPAN,ISPIN),
     &  TNY(L,ISORT,IKAP,IPAN,ISPIN),ENY(L,ISORT,IKAP,IPAN,ISPIN),
     &  ISORT,L+1,ISPIN)
	ELSEIF(MNY(L,ISORT,IKAP,IPAN).EQ.2)THEN
C  FIND BINDING ENERGY E FOR GIVEN VALENCE STATE
        CALL ENYCOR(ENY(L,ISORT,IKAP,IPAN,ISPIN),NODES(L,
     &  ISORT,IKAP,IPAN),L,-1,DLOG,SMT(ISORT),VSPH(0,ISORT,
     &  ISPIN),APHI(0),APHID(0),NRAD(ISORT),H(ISORT),
     &  R(0,ISORT),DR(0,ISORT),LR(ISORT))
	DHLOG(L,ISORT,IKAP,IPAN,ISPIN)=DLOG
	ENDIF
        ENDDO                                                !!! over l
        ENDDO                                                !!! over ikap
	DO 500 L=0,ILSB(ISORT)                               !!! over l
C  SORT ENY IN INCREASING ORDER
	DO IKAP=1,NKAP(IPAN)
	INC(IKAP)=0
	ENDDO
	DO IKAP=1,NKAP(IPAN)
	IN=1
	DO JKAP=1,NKAP(IPAN)
	IF(ENY(L,ISORT,IKAP,IPAN,ISPIN).GT.
     &  ENY(L,ISORT,JKAP,IPAN,ISPIN))IN=IN+1
	ENDDO
	DO II=IN,NKAP(IPAN)
	IF(INC(II).EQ.0)THEN
	INC(II)=IKAP
	EXIT
	ENDIF
	ENDDO
	ENDDO
C  CHECK ENERGY DISTANCES BETWEEN ENY 
	DO IKAP=1,NKAP(IPAN)
	DO JKAP=IKAP+1,NKAP(IPAN)
	DIFF=ENY(L,ISORT,INC(JKAP),IPAN,ISPIN)-
     &  ENY(L,ISORT,INC(IKAP),IPAN,ISPIN)
	IF(ABS(DIFF).GE.1.D-10.AND.
     &     LNY(L,ISORT,INC(JKAP),IPAN).EQ.
     &     LNY(L,ISORT,INC(IKAP),IPAN))THEN
	PRINT*,'<SETENY>: ENY FOR THE SAME CLASS DIFFER!',
     &  'L,ISORT,IKAP1,IKAP==',
     &  DIFF,L,ISORT,INC(JKAP),INC(IKAP)
        ENY(L,ISORT,INC(JKAP),IPAN,ISPIN)=
     &  ENY(L,ISORT,INC(IKAP),IPAN,ISPIN)
	PRINT*,'STANDARD CORRECTION IS TAKEN PLACE'
	ELSEIF(ABS(DIFF).LT.0.1D0.AND.
     &     LNY(L,ISORT,INC(JKAP),IPAN).NE.
     &     LNY(L,ISORT,INC(IKAP),IPAN))THEN
 	PRINT*,'<SETENY>: DIFFERENCE BETWEEN ENY IS TOO SMALL!',
     &  'L,ISORT,IKAP1,IKAP==',
     &  DIFF,L,ISORT,INC(JKAP),INC(IKAP)
        ENY(L,ISORT,INC(JKAP),IPAN,ISPIN)=
     &  ENY(L,ISORT,INC(IKAP),IPAN,ISPIN)+0.1D0
 	PRINT*,'STANDARD CORRECTION IS TAKEN PLACE'
	ENDIF
        ENDDO   
        ENDDO    
 500    CONTINUE                                             !!! over l
1000    CONTINUE                                             !!! over isort
2000	CONTINUE                                             !!! over ispin
	END





	SUBROUTINE SKKRPAR(IPAN)
****************************************************************
*  Subroutine  finds KKR-position of band center and effective *
*  band width.                                                 * 
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NHSORT(NSORTMAX),IS(NPAT),NRAD(NSORTMAX),NKAP(NPANMAX)
     &   ,NODES(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX),LR(NSORTMAX)
     &   ,MNY  (0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX),INC(NKAPMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
	DIMENSION R(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &   ,DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,CNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,WNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,VNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,DHLOG(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX),H(NSORTMAX)
     &   ,SMT(NSORTMAX),AFIS(0:LMAXT),AFIPS(0:LMAXT)
     &   ,DNYCEN(0:LMAXT),TNYCEN(0:LMAXT),DNYP(0:LMAXT)
     &   ,FPMN(0:LMAXT),SASA(NSORTMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	CHARACTER TXTEL(NSORTMAX)*10
C Controls:
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from readini
	COMMON /SPIN/   NSPIN                                !!! from readini
	COMMON /RELATIV/LR                                   !!! from readini
C Inputs:
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from readini
	COMMON /POTCOM/ SWZ,SMT,VSPH                         !!! from vfull
	COMMON /KAPPAR/ NPAN,NKAP                            !!! from readini
C Pot.pars:
	COMMON /INPPAR/ TNY,ENY,DNY,NODES,MNY,DHLOG          !!! from seteny
	COMMON /KKRPAR/ CNY,WNY,VNY                          !!! from kkrpar
C Rad.mesh:
	COMMON /RADMESH/NRAD,H,R,DR                          !!! from radmesh
	COMMON /ASASPH/ SASA                                 !!! from readini
C Outputs:
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /TXTEL/  TXTEL                                !!! from init
	DATA PI/3.141592653589793D0/
	DO ISPIN=1,NSPIN                                     !!! over ispin
	DO ISORT=1,NSORT                                     !!! over isort
	DO IKAP=1,NKAP(IPAN)                                 !!! over ikap
C  FIND PARAMETERS FOR THE CHOICE D=-L-1
	DO L=0,ILST(ISORT)                                   !!! over l
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
C  FIND KKR-BAND CENTER
	TNYCEN(L)=0.5D0+NODES(L,ISORT,IKAP,IPAN)-ATAN(DBLE(-L-1))/PI
	CALL ENSEARCH(ENY(L,ISORT,IKAP,IPAN,ISPIN),TNYCEN(L),
     &  CNY(L,ISORT,IKAP,IPAN,ISPIN),ISORT,L+1,ISPIN)
	ELSE
	CNY(L,ISORT,IKAP,IPAN,ISPIN)=ENY(L,ISORT,IKAP,IPAN,ISPIN)
	ENDIF
        ENDDO                                                !!! over l
C  SOLVE SCHROEDINGER'S EQUATION FOR THE CNY
        CALL RUNGE(CNY(0,ISORT,IKAP,IPAN,ISPIN),AFIS(0),
     &  AFIPS(0),DNYCEN(0),TNYCEN(0),DNYP(0),FPMN(0),SMT(ISORT),
     &  VSPH(0,ISORT,ISPIN),ILST(ISORT),NRAD(ISORT),
     &  H(ISORT),R(0,ISORT),DR(0,ISORT),LR(ISORT))
C  ESTIMATE HALF OF BAND WIDTH
	DO L=0,ILSB(ISORT)                                   !!! over l
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
	IF(ABS(DNYCEN(L)+DBLE(L+1)).GE.1.D-08)PRINT*,
     &  '<SKKRPAR>: LOST OF ACCURACY, ERROR IS ',DNYCEN(L)+DBLE(L+1)
	IF(L.NE.0)
     &  WNY(L,ISORT,IKAP,IPAN,ISPIN)=SMT(ISORT)*AFIS(L)**2/2.D0
     &  *(SASA(ISORT)/SWZ)**(2*L+1)*DBLE(2*L+1)**2/DBLE(L)
	ENDIF
        ENDDO                                                !!! over l
C  FIND PARAMETERS FOR THE CHOICE D=L
	DO L=0,ILST(ISORT)                                   !!! over l
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
C  FIND KKR-BAND EDGE
	TNYCEN(L)=0.5D0+NODES(L,ISORT,IKAP,IPAN)-ATAN(DBLE(L))/PI
	CALL ENSEARCH(ENY(L,ISORT,IKAP,IPAN,ISPIN),TNYCEN(L),
     &  VNY(L,ISORT,IKAP,IPAN,ISPIN),ISORT,L+1,ISPIN)
	ELSE
	VNY(L,ISORT,IKAP,IPAN,ISPIN)=ENY(L,ISORT,IKAP,IPAN,ISPIN)
	ENDIF
        ENDDO                                                !!! over l
C  SOLVE SCHROEDINGER'S EQUATION FOR THE VNY
        CALL RUNGE(VNY(0,ISORT,IKAP,IPAN,ISPIN),AFIS(0),
     &  AFIPS(0),DNYCEN(0),TNYCEN(0),DNYP(0),FPMN(0),SMT(ISORT),
     &  VSPH(0,ISORT,ISPIN),ILST(ISORT),NRAD(ISORT),
     &  H(ISORT),R(0,ISORT),DR(0,ISORT),LR(ISORT))
C  ESTIMATE HALF OF BAND WIDTH FOR L=0
	DO L=0,ILSB(ISORT)                                   !!! over l
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
	IF(ABS(DNYCEN(L)-DBLE(L)).GE.1.D-08)PRINT*,
     &  '<SKKRPAR>: LOST OF ACCURACY, ERROR IS ',DNYCEN(L)-DBLE(L)
	TS21=SMT(ISORT)*AFIS(L)**2/DBLE(2*L+3)
	GAM1=DBLE(2*(2*L+1))*(1.D0-DBLE(2*L+1)*SMT(ISORT)*AFIS(L)*
     &  AFIPS(L))
	IF(L.EQ.0)
     &  WNY(L,ISORT,IKAP,IPAN,ISPIN)=TS21*6.D0/(GAM1-2.D0)*
     &  (SASA(ISORT)/SWZ)**(2*L+1)
	ENDIF
        ENDDO                                                !!! over l
        ENDDO                                                !!! over ikap
        ENDDO                                                !!! over isort
        ENDDO                                                !!! over ispin
	END
